diff -Naur a/src/buildtools/config/windows.pri b/src/buildtools/config/windows.pri
--- a/src/buildtools/config/windows.pri	2021-08-24 13:35:32.000000000 +0100
+++ b/src/buildtools/config/windows.pri	2021-11-20 03:27:42.386569236 +0000
@@ -71,7 +71,7 @@
 msvc {
     equals(MSVC_VER, 15.0) {
         MSVS_VERSION = 2017
-    } else: equals(MSVC_VER, 16.0) {
+    } else: versionAtLeast(MSVC_VER, 16.0) {
         MSVS_VERSION = 2019
     } else {
         error("Visual Studio compiler version \"$$MSVC_VER\" is not supported by gn.")
diff -Naur a/src/core/media_capture_devices_dispatcher.cpp b/src/core/media_capture_devices_dispatcher.cpp
--- a/src/core/media_capture_devices_dispatcher.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/src/core/media_capture_devices_dispatcher.cpp	2021-11-20 03:32:41.112942241 +0000
@@ -70,6 +70,7 @@
 #endif
 
 #include <QtCore/qcoreapplication.h>
+#include <QtCore/qscopeguard.h>
 
 #if defined(WEBRTC_USE_X11)
 #include <dlfcn.h>
@@ -197,6 +198,7 @@
 
     int numMonitors = 0;
     XRRMonitorInfo *monitors = getMonitors(display, rootWindow, true, &numMonitors);
+    auto cleanup = qScopeGuard([&] () { freeMonitors(monitors); });
     if (numMonitors > 0)
         return content::DesktopMediaID(content::DesktopMediaID::TYPE_SCREEN, monitors[0].name);
 #endif // !defined(WEBRTC_USE_X11)
diff -Naur a/src/core/net/proxying_url_loader_factory_qt.cpp b/src/core/net/proxying_url_loader_factory_qt.cpp
--- a/src/core/net/proxying_url_loader_factory_qt.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/src/core/net/proxying_url_loader_factory_qt.cpp	2021-11-20 03:32:13.929364759 +0000
@@ -47,8 +47,11 @@
 #include "content/public/browser/browser_task_traits.h"
 #include "content/public/browser/browser_thread.h"
 #include "content/public/browser/web_contents.h"
+#include "content/public/common/content_switches.h"
 #include "net/http/http_status_code.h"
+#include "services/network/public/cpp/cors/cors.h"
 #include "third_party/blink/public/mojom/loader/resource_load_info.mojom-shared.h"
+#include "url/url_util.h"
 
 #include "api/qwebengineurlrequestinfo_p.h"
 #include "type_conversion.h"
@@ -162,6 +165,7 @@
     const uint64_t request_id_;
     const int32_t routing_id_;
     const uint32_t options_;
+    bool allowed_cors_ = true;
 
     // If the |target_loader_| called OnComplete with an error this stores it.
     // That way the destructor can send it to OnReceivedError if safe browsing
@@ -204,12 +208,37 @@
     , target_factory_(std::move(target_factory))
     , weak_factory_(this)
 {
+    const bool disable_web_security = base::CommandLine::ForCurrentProcess()->HasSwitch(switches::kDisableWebSecurity);
     current_response_ = network::mojom::URLResponseHead::New();
+    current_response_->response_type = network::cors::CalculateResponseType(
+        request_.mode,
+        disable_web_security || (
+            request_.request_initiator && request_.request_initiator->IsSameOriginWith(url::Origin::Create(request_.url))));
     // If there is a client error, clean up the request.
     target_client_.set_disconnect_handler(
-            base::BindOnce(&InterceptedRequest::OnURLLoaderClientError, weak_factory_.GetWeakPtr()));
+            base::BindOnce(&InterceptedRequest::OnURLLoaderClientError, base::Unretained(this)));
     proxied_loader_receiver_.set_disconnect_with_reason_handler(
-            base::BindOnce(&InterceptedRequest::OnURLLoaderError, weak_factory_.GetWeakPtr()));
+            base::BindOnce(&InterceptedRequest::OnURLLoaderError, base::Unretained(this)));
+    if (!disable_web_security && request_.request_initiator) {
+        const std::vector<std::string> &localSchemes = url::GetLocalSchemes();
+        std::string fromScheme = request_.request_initiator->GetTupleOrPrecursorTupleIfOpaque().scheme();
+        if (base::Contains(localSchemes, fromScheme)) {
+            content::WebContents *wc = webContents();
+            std::string toScheme = request_.url.scheme();
+            // local schemes must have universal access, or be accessing something local and have local access.
+            if (fromScheme != toScheme) {
+                // note allow_file_access_from_file_urls maps to LocalContentCanAccessFileUrls in our API
+                // and allow_universal_access_from_file_urls to LocalContentCanAccessRemoteUrls, so we are
+                // using them as proxies for our API here.
+                if (toScheme == "file")
+                    allowed_cors_ = wc && wc->GetOrCreateWebPreferences().allow_file_access_from_file_urls;
+                else if (!base::Contains(localSchemes, toScheme))
+                    allowed_cors_ = wc && wc->GetOrCreateWebPreferences().allow_universal_access_from_file_urls;
+                else
+                    allowed_cors_ = true; // We should think about this for future patches
+            }
+        }
+    }
 }
 
 InterceptedRequest::~InterceptedRequest()
@@ -246,6 +275,14 @@
 {
     DCHECK_CURRENTLY_ON(content::BrowserThread::UI);
 
+    // This is a CORS check on the from URL, the normal check on the to URL is applied later
+    if (!allowed_cors_ && current_response_->response_type == network::mojom::FetchResponseType::kCors) {
+        target_client_->OnComplete(network::URLLoaderCompletionStatus(
+                                       network::CorsErrorStatus(network::mojom::CorsError::kCorsDisabledScheme)));
+        delete this;
+        return;
+    }
+
     // MEMO since all codepatch leading to Restart scheduled and executed as asynchronous tasks in main thread,
     //      interceptors may change in meantime and also during intercept call, so they should be resolved anew.
     //      Set here only profile's interceptor since it runs first without going to user code.
diff -Naur a/src/core/ozone/ozone_platform_qt.cpp b/src/core/ozone/ozone_platform_qt.cpp
--- a/src/core/ozone/ozone_platform_qt.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/src/core/ozone/ozone_platform_qt.cpp	2021-11-20 03:32:51.938773974 +0000
@@ -164,7 +164,17 @@
     if (XkbGetState(dpy, XkbUseCoreKbd, &state) != 0)
         return std::string();
 
-    XkbRF_VarDefsRec vdr;
+    XkbRF_VarDefsRec vdr {}; // zero initialize it
+    struct Cleanup {
+        XkbRF_VarDefsRec &vdr;
+        Cleanup(XkbRF_VarDefsRec &vdr) : vdr(vdr) { }
+        ~Cleanup() {
+            free (vdr.model);
+            free (vdr.layout);
+            free (vdr.variant);
+            free (vdr.options);
+        }
+    } cleanup(vdr);
     if (XkbRF_GetNamesProp(dpy, nullptr, &vdr) == 0)
         return std::string();
 
diff -Naur a/src/core/render_widget_host_view_qt.cpp b/src/core/render_widget_host_view_qt.cpp
--- a/src/core/render_widget_host_view_qt.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/src/core/render_widget_host_view_qt.cpp	2021-11-20 03:33:03.760590226 +0000
@@ -1662,7 +1662,8 @@
 {
     const Qt::NativeGestureType type = ev->gestureType();
     // These are the only supported gestures by Chromium so far.
-    if (type == Qt::ZoomNativeGesture || type == Qt::SmartZoomNativeGesture) {
+    if (type == Qt::ZoomNativeGesture || type == Qt::SmartZoomNativeGesture
+            || type == Qt::BeginNativeGesture || type == Qt::EndNativeGesture) {
         if (host()->delegate() && host()->delegate()->GetInputEventRouter()) {
             auto webEvent = WebEventFactory::toWebGestureEvent(ev);
             host()->delegate()->GetInputEventRouter()->RouteGestureEvent(this, &webEvent, ui::LatencyInfo());
diff -Naur a/src/core/web_event_factory.cpp b/src/core/web_event_factory.cpp
--- a/src/core/web_event_factory.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/src/core/web_event_factory.cpp	2021-11-20 03:33:03.760590226 +0000
@@ -1540,7 +1540,13 @@
         webKitEvent.data.tap.tap_count = 1;
         break;
     case Qt::BeginNativeGesture:
+        webKitEvent.SetType(WebInputEvent::Type::kGesturePinchBegin);
+        webKitEvent.SetNeedsWheelEvent(true);
+        break;
     case Qt::EndNativeGesture:
+        webKitEvent.SetType(WebInputEvent::Type::kGesturePinchEnd);
+        webKitEvent.SetNeedsWheelEvent(true);
+        break;
     case Qt::RotateNativeGesture:
     case Qt::PanNativeGesture:
     case Qt::SwipeNativeGesture:
diff -Naur a/src/webenginewidgets/doc/src/qwebenginesettings_lgpl.qdoc b/src/webenginewidgets/doc/src/qwebenginesettings_lgpl.qdoc
--- a/src/webenginewidgets/doc/src/qwebenginesettings_lgpl.qdoc	2021-08-24 13:35:32.000000000 +0100
+++ b/src/webenginewidgets/doc/src/qwebenginesettings_lgpl.qdoc	2021-11-20 03:32:13.929364759 +0000
@@ -106,13 +106,11 @@
             Enables support for the HTML 5 local storage feature. Enabled by default.
     \value  LocalContentCanAccessRemoteUrls
             Allows locally loaded documents to ignore cross-origin rules so that they can access
-            remote resources that would normally be blocked, because all remote resources are
-            considered cross-origin for a local file. Remote access that would not be blocked by
+            remote resources that would normally be blocked, since remote resources are
+            considered cross-origin for a local document. Remote access that would not be blocked by
             cross-origin rules is still possible when this setting is disabled (default).
-            Note that disabling this setting does not stop XMLHttpRequests or media elements in
-            local files from accessing remote content. Basically, it only stops some HTML
-            subresources, such as scripts, and therefore disabling this setting is not a safety
-            mechanism.
+            Note that disabling this setting does not prevent media elements in local files from
+            accessing remote content. Disabled by default.
     \value  XSSAuditingEnabled
             Obsolete and has no effect.
     \value  SpatialNavigationEnabled
@@ -123,7 +121,8 @@
             trying to reach towards the right and which element they probably want.
             Disabled by default.
     \value  LocalContentCanAccessFileUrls
-            Allows locally loaded documents to access other local URLs. Enabled by default.
+            Allows locally loaded documents to access other local URLs. Disabling this makes QtWebEngine
+            behave more like Chrome and Firefox does by default. Enabled by default.
     \value  HyperlinkAuditingEnabled
             Enables support for the \c ping attribute for hyperlinks. Disabled by default.
     \value  ScrollAnimatorEnabled
diff -Naur a/tests/auto/quick/qmltests/BLACKLIST b/tests/auto/quick/qmltests/BLACKLIST
--- a/tests/auto/quick/qmltests/BLACKLIST	2021-08-24 13:35:32.000000000 +0100
+++ b/tests/auto/quick/qmltests/BLACKLIST	2021-11-20 03:32:28.281141688 +0000
@@ -1,2 +1,5 @@
 [NewViewRequest::test_loadNewViewRequest]
 macos
+
+[CertificateError::test_fatalError]
+*
diff -Naur a/tests/auto/widgets/certificateerror/BLACKLIST b/tests/auto/widgets/certificateerror/BLACKLIST
--- a/tests/auto/widgets/certificateerror/BLACKLIST	1970-01-01 01:00:00.000000000 +0100
+++ b/tests/auto/widgets/certificateerror/BLACKLIST	2021-11-20 03:32:28.281141688 +0000
@@ -0,0 +1,2 @@
+[fatalError]
+*
diff -Naur a/tests/auto/widgets/origins/tst_origins.cpp b/tests/auto/widgets/origins/tst_origins.cpp
--- a/tests/auto/widgets/origins/tst_origins.cpp	2021-08-24 13:35:32.000000000 +0100
+++ b/tests/auto/widgets/origins/tst_origins.cpp	2021-11-20 03:32:13.929364759 +0000
@@ -657,7 +657,7 @@
                                 << QVariant(QString("ok"));
     QTest::newRow("file->cors") << QString("file:" THIS_DIR "resources/mixedXHR.html")
                                 << QString("sendXHR('cors:/resources/mixedXHR.txt')")
-                                << QVariant(QString("ok"));
+                                << QVariant(QString("error"));
 
     QTest::newRow("qrc->file") << QString("qrc:/resources/mixedXHR.html")
                                << QString("sendXHR('file:" THIS_DIR "resources/mixedXHR.txt')")
